<?php

namespace SabrePaymentGateway;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'PaymentRQ' => '\\SabrePaymentGateway\\StructType\\PaymentRQ',
            'Action' => '\\SabrePaymentGateway\\StructType\\Action',
            'ServiceIndicator' => '\\SabrePaymentGateway\\StructType\\ServiceIndicator',
            'OrderDetail' => '\\SabrePaymentGateway\\StructType\\OrderDetail',
            'MsfAgencyFeeDetail' => '\\SabrePaymentGateway\\StructType\\MsfAgencyFeeDetail',
            'CustomerDetail' => '\\SabrePaymentGateway\\StructType\\CustomerDetail',
            'PaymentRS' => '\\SabrePaymentGateway\\StructType\\PaymentRS',
            'Result' => '\\SabrePaymentGateway\\StructType\\Result',
            'Results' => '\\SabrePaymentGateway\\StructType\\Results',
            'FOP' => '\\SabrePaymentGateway\\StructType\\FOP',
            'AccountValidationResult' => '\\SabrePaymentGateway\\StructType\\AccountValidationResult',
            'BalanceInquiryResult' => '\\SabrePaymentGateway\\StructType\\BalanceInquiryResult',
            'VerificationResult' => '\\SabrePaymentGateway\\StructType\\VerificationResult',
            'DCC_Result' => '\\SabrePaymentGateway\\StructType\\DCC_Result',
            'MCP_Result' => '\\SabrePaymentGateway\\StructType\\MCP_Result',
            'MCP_Offer' => '\\SabrePaymentGateway\\StructType\\MCP_Offer',
            'GetCardResult' => '\\SabrePaymentGateway\\StructType\\GetCardResult',
            'QueryDeferredPaymentResult' => '\\SabrePaymentGateway\\StructType\\QueryDeferredPaymentResult',
            'GetBINResult' => '\\SabrePaymentGateway\\StructType\\GetBINResult',
            'CaptureResult' => '\\SabrePaymentGateway\\StructType\\CaptureResult',
            'AccountDetail' => '\\SabrePaymentGateway\\StructType\\AccountDetail',
            'ListOfVouchers' => '\\SabrePaymentGateway\\StructType\\ListOfVouchers',
            'DeferredPaymentDetail' => '\\SabrePaymentGateway\\StructType\\DeferredPaymentDetail',
            'CardDetail' => '\\SabrePaymentGateway\\StructType\\CardDetail',
            'FraudRemarks' => '\\SabrePaymentGateway\\StructType\\FraudRemarks',
            'NotificationList' => '\\SabrePaymentGateway\\StructType\\NotificationList',
            'Notification' => '\\SabrePaymentGateway\\StructType\\Notification',
            'DBIItems' => '\\SabrePaymentGateway\\StructType\\DBIItems',
            'PassengerDetail' => '\\SabrePaymentGateway\\StructType\\PassengerDetail',
            'AccountDetailType' => '\\SabrePaymentGateway\\StructType\\AccountDetailType',
            'AddressType' => '\\SabrePaymentGateway\\StructType\\AddressType',
            'StateProv' => '\\SabrePaymentGateway\\StructType\\StateProv',
            'AuthenticationDetailType' => '\\SabrePaymentGateway\\StructType\\AuthenticationDetailType',
            'AuthorizationResultType' => '\\SabrePaymentGateway\\StructType\\AuthorizationResultType',
            'CardReaderResult' => '\\SabrePaymentGateway\\StructType\\CardReaderResult',
            'T3DS_Result' => '\\SabrePaymentGateway\\StructType\\T3DS_Result',
            'PIN_Result' => '\\SabrePaymentGateway\\StructType\\PIN_Result',
            'AuthResponseDetail' => '\\SabrePaymentGateway\\StructType\\AuthResponseDetail',
            'LocalCardDetail' => '\\SabrePaymentGateway\\StructType\\LocalCardDetail',
            'AdditionalApprovals' => '\\SabrePaymentGateway\\StructType\\AdditionalApprovals',
            'Approval' => '\\SabrePaymentGateway\\StructType\\Approval',
            'VoucherDetail' => '\\SabrePaymentGateway\\StructType\\VoucherDetail',
            'ListOfReferenceNbrs' => '\\SabrePaymentGateway\\StructType\\ListOfReferenceNbrs',
            'NetworkTokenDetail' => '\\SabrePaymentGateway\\StructType\\NetworkTokenDetail',
            'AccountValidationResultType' => '\\SabrePaymentGateway\\StructType\\AccountValidationResultType',
            'AVS_ResultType' => '\\SabrePaymentGateway\\StructType\\AVS_ResultType',
            'CancelAuthResultType' => '\\SabrePaymentGateway\\StructType\\CancelAuthResultType',
            'CarRentalType' => '\\SabrePaymentGateway\\StructType\\CarRentalType',
            'Pickup' => '\\SabrePaymentGateway\\StructType\\Pickup',
            'Return' => '\\SabrePaymentGateway\\StructType\\_Return',
            'Renter' => '\\SabrePaymentGateway\\StructType\\Renter',
            'ConfirmAuthResultType' => '\\SabrePaymentGateway\\StructType\\ConfirmAuthResultType',
            'ContactInfoType' => '\\SabrePaymentGateway\\StructType\\ContactInfoType',
            'CostType' => '\\SabrePaymentGateway\\StructType\\CostType',
            'CountryNameType' => '\\SabrePaymentGateway\\StructType\\CountryNameType',
            'CSC_ResultType' => '\\SabrePaymentGateway\\StructType\\CSC_ResultType',
            'CurrencyAmountType' => '\\SabrePaymentGateway\\StructType\\CurrencyAmountType',
            'DCCType' => '\\SabrePaymentGateway\\StructType\\DCCType',
            'MCPType' => '\\SabrePaymentGateway\\StructType\\MCPType',
            'DocumentType' => '\\SabrePaymentGateway\\StructType\\DocumentType',
            'EMD_CouponDetail' => '\\SabrePaymentGateway\\StructType\\EMD_CouponDetail',
            'FareBreakType' => '\\SabrePaymentGateway\\StructType\\FareBreakType',
            'FeeBreakType' => '\\SabrePaymentGateway\\StructType\\FeeBreakType',
            'FlightDetailType' => '\\SabrePaymentGateway\\StructType\\FlightDetailType',
            'DepartureInfo' => '\\SabrePaymentGateway\\StructType\\DepartureInfo',
            'ArrivalInfo' => '\\SabrePaymentGateway\\StructType\\ArrivalInfo',
            'FOP_FareBreakType' => '\\SabrePaymentGateway\\StructType\\FOP_FareBreakType',
            'FOPType' => '\\SabrePaymentGateway\\StructType\\FOPType',
            'FraudScreenResultType' => '\\SabrePaymentGateway\\StructType\\FraudScreenResultType',
            'GetCardResultType' => '\\SabrePaymentGateway\\StructType\\GetCardResultType',
            'GuestType' => '\\SabrePaymentGateway\\StructType\\GuestType',
            'HotelType' => '\\SabrePaymentGateway\\StructType\\HotelType',
            'IssuerNameType' => '\\SabrePaymentGateway\\StructType\\IssuerNameType',
            'MerchantDetailType' => '\\SabrePaymentGateway\\StructType\\MerchantDetailType',
            'MiscItemType' => '\\SabrePaymentGateway\\StructType\\MiscItemType',
            'NameValueType' => '\\SabrePaymentGateway\\StructType\\NameValueType',
            'PassengerDetailType' => '\\SabrePaymentGateway\\StructType\\PassengerDetailType',
            'Document' => '\\SabrePaymentGateway\\StructType\\Document',
            'PaymentCardType' => '\\SabrePaymentGateway\\StructType\\PaymentCardType',
            'T3DS' => '\\SabrePaymentGateway\\StructType\\T3DS',
            'CardReader' => '\\SabrePaymentGateway\\StructType\\CardReader',
            'CardHolderName' => '\\SabrePaymentGateway\\StructType\\CardHolderName',
            'Identifications' => '\\SabrePaymentGateway\\StructType\\Identifications',
            'CardIssuerName' => '\\SabrePaymentGateway\\StructType\\CardIssuerName',
            'VCL_Info' => '\\SabrePaymentGateway\\StructType\\VCL_Info',
            'VirtualCard' => '\\SabrePaymentGateway\\StructType\\VirtualCard',
            'PaymentDetailType' => '\\SabrePaymentGateway\\StructType\\PaymentDetailType',
            'PaymentCard' => '\\SabrePaymentGateway\\StructType\\PaymentCard',
            'AmountDetail' => '\\SabrePaymentGateway\\StructType\\AmountDetail',
            'AuthorizationResult' => '\\SabrePaymentGateway\\StructType\\AuthorizationResult',
            'CardUsageResult' => '\\SabrePaymentGateway\\StructType\\CardUsageResult',
            'RoutingDetail' => '\\SabrePaymentGateway\\StructType\\RoutingDetail',
            'InstallmentDetail' => '\\SabrePaymentGateway\\StructType\\InstallmentDetail',
            'VirtualPaymentDetail' => '\\SabrePaymentGateway\\StructType\\VirtualPaymentDetail',
            'PaymentInfoType' => '\\SabrePaymentGateway\\StructType\\PaymentInfoType',
            'PersonID_Type' => '\\SabrePaymentGateway\\StructType\\PersonID_Type',
            'Passport' => '\\SabrePaymentGateway\\StructType\\Passport',
            'Visa' => '\\SabrePaymentGateway\\StructType\\Visa',
            'Other' => '\\SabrePaymentGateway\\StructType\\Other',
            'PhoneType' => '\\SabrePaymentGateway\\StructType\\PhoneType',
            'POS_Type' => '\\SabrePaymentGateway\\StructType\\POS_Type',
            'BrowserDetail' => '\\SabrePaymentGateway\\StructType\\BrowserDetail',
            'HttpHeaders' => '\\SabrePaymentGateway\\StructType\\HttpHeaders',
            'HttpHeader' => '\\SabrePaymentGateway\\StructType\\HttpHeader',
            'ProductDetailType' => '\\SabrePaymentGateway\\StructType\\ProductDetailType',
            'ProviderInfoType' => '\\SabrePaymentGateway\\StructType\\ProviderInfoType',
            'RailJourneyType' => '\\SabrePaymentGateway\\StructType\\RailJourneyType',
            'Ticket' => '\\SabrePaymentGateway\\StructType\\Ticket',
            'RailType' => '\\SabrePaymentGateway\\StructType\\RailType',
            'RefundResultType' => '\\SabrePaymentGateway\\StructType\\RefundResultType',
            'CancelRefundResultType' => '\\SabrePaymentGateway\\StructType\\CancelRefundResultType',
            'RemarksType' => '\\SabrePaymentGateway\\StructType\\RemarksType',
            'ReturnURLsType' => '\\SabrePaymentGateway\\StructType\\ReturnURLsType',
            'RoomStayType' => '\\SabrePaymentGateway\\StructType\\RoomStayType',
            'StateProvType' => '\\SabrePaymentGateway\\StructType\\StateProvType',
            'StreetNmbrType' => '\\SabrePaymentGateway\\StructType\\StreetNmbrType',
            'SubBalanceType' => '\\SabrePaymentGateway\\StructType\\SubBalanceType',
            'SupplierMessagesType' => '\\SabrePaymentGateway\\StructType\\SupplierMessagesType',
            'TaxType' => '\\SabrePaymentGateway\\StructType\\TaxType',
            'TokenizationResultType' => '\\SabrePaymentGateway\\StructType\\TokenizationResultType',
            'TokensType' => '\\SabrePaymentGateway\\StructType\\TokensType',
            'Token' => '\\SabrePaymentGateway\\StructType\\Token',
            'TPA_ExtensionsType' => '\\SabrePaymentGateway\\StructType\\TPA_ExtensionsType',
            'VoucherType' => '\\SabrePaymentGateway\\StructType\\VoucherType',
            'RegisterAuthResultType' => '\\SabrePaymentGateway\\StructType\\RegisterAuthResultType',
            'AdditionalDetailType' => '\\SabrePaymentGateway\\StructType\\AdditionalDetailType',
            'Field' => '\\SabrePaymentGateway\\StructType\\Field',
            'LoyaltyMembershipDetailType' => '\\SabrePaymentGateway\\StructType\\LoyaltyMembershipDetailType',
            'ReferenceNbrType' => '\\SabrePaymentGateway\\StructType\\ReferenceNbrType',
            'T3DS_ResultType' => '\\SabrePaymentGateway\\StructType\\T3DS_ResultType',
            'ValidateAndQueryPaymentDetailResultType' => '\\SabrePaymentGateway\\StructType\\ValidateAndQueryPaymentDetailResultType',
            'RemarkLinesType' => '\\SabrePaymentGateway\\StructType\\RemarkLinesType',
            'GetDeploymentResultType' => '\\SabrePaymentGateway\\StructType\\GetDeploymentResultType',
            'CustomIdentifiersType' => '\\SabrePaymentGateway\\StructType\\CustomIdentifiersType',
            'CustomIdentifier' => '\\SabrePaymentGateway\\StructType\\CustomIdentifier',
            'UpdateDeploymentResultType' => '\\SabrePaymentGateway\\StructType\\UpdateDeploymentResultType',
            'GetCardActivityResultType' => '\\SabrePaymentGateway\\StructType\\GetCardActivityResultType',
            'CardActivityType' => '\\SabrePaymentGateway\\StructType\\CardActivityType',
            'T3DS_AuthenticationResultType' => '\\SabrePaymentGateway\\StructType\\T3DS_AuthenticationResultType',
            'SignatureType' => '\\SabrePaymentGateway\\StructType\\SignatureType',
            'SignatureValueType' => '\\SabrePaymentGateway\\StructType\\SignatureValueType',
            'SignedInfoType' => '\\SabrePaymentGateway\\StructType\\SignedInfoType',
            'CanonicalizationMethodType' => '\\SabrePaymentGateway\\StructType\\CanonicalizationMethodType',
            'SignatureMethodType' => '\\SabrePaymentGateway\\StructType\\SignatureMethodType',
            'ReferenceType' => '\\SabrePaymentGateway\\StructType\\ReferenceType',
            'TransformsType' => '\\SabrePaymentGateway\\StructType\\TransformsType',
            'TransformType' => '\\SabrePaymentGateway\\StructType\\TransformType',
            'DigestMethodType' => '\\SabrePaymentGateway\\StructType\\DigestMethodType',
            'KeyInfoType' => '\\SabrePaymentGateway\\StructType\\KeyInfoType',
            'KeyValueType' => '\\SabrePaymentGateway\\StructType\\KeyValueType',
            'RetrievalMethodType' => '\\SabrePaymentGateway\\StructType\\RetrievalMethodType',
            'X509DataType' => '\\SabrePaymentGateway\\StructType\\X509DataType',
            'X509IssuerSerialType' => '\\SabrePaymentGateway\\StructType\\X509IssuerSerialType',
            'PGPDataType' => '\\SabrePaymentGateway\\StructType\\PGPDataType',
            'SPKIDataType' => '\\SabrePaymentGateway\\StructType\\SPKIDataType',
            'ObjectType' => '\\SabrePaymentGateway\\StructType\\ObjectType',
            'ManifestType' => '\\SabrePaymentGateway\\StructType\\ManifestType',
            'SignaturePropertiesType' => '\\SabrePaymentGateway\\StructType\\SignaturePropertiesType',
            'SignaturePropertyType' => '\\SabrePaymentGateway\\StructType\\SignaturePropertyType',
            'DSAKeyValueType' => '\\SabrePaymentGateway\\StructType\\DSAKeyValueType',
            'RSAKeyValueType' => '\\SabrePaymentGateway\\StructType\\RSAKeyValueType',
            'Envelope' => '\\SabrePaymentGateway\\StructType\\Envelope',
            'Header' => '\\SabrePaymentGateway\\StructType\\Header',
            'Body' => '\\SabrePaymentGateway\\StructType\\Body',
            'Fault' => '\\SabrePaymentGateway\\StructType\\Fault',
            'detail' => '\\SabrePaymentGateway\\StructType\\Detail',
            'Manifest' => '\\SabrePaymentGateway\\StructType\\Manifest',
            'Reference' => '\\SabrePaymentGateway\\StructType\\Reference',
            'Schema' => '\\SabrePaymentGateway\\StructType\\Schema',
            'MessageHeader' => '\\SabrePaymentGateway\\StructType\\MessageHeader',
            'Service' => '\\SabrePaymentGateway\\StructType\\Service',
            'MessageData' => '\\SabrePaymentGateway\\StructType\\MessageData',
            'SyncReply' => '\\SabrePaymentGateway\\StructType\\SyncReply',
            'MessageOrder' => '\\SabrePaymentGateway\\StructType\\MessageOrder',
            'AckRequested' => '\\SabrePaymentGateway\\StructType\\AckRequested',
            'Acknowledgment' => '\\SabrePaymentGateway\\StructType\\Acknowledgment',
            'ErrorList' => '\\SabrePaymentGateway\\StructType\\ErrorList',
            'Error' => '\\SabrePaymentGateway\\StructType\\Error',
            'StatusResponse' => '\\SabrePaymentGateway\\StructType\\StatusResponse',
            'StatusRequest' => '\\SabrePaymentGateway\\StructType\\StatusRequest',
            'sequenceNumber.type' => '\\SabrePaymentGateway\\StructType\\SequenceNumber_type',
            'PartyId' => '\\SabrePaymentGateway\\StructType\\PartyId',
            'To' => '\\SabrePaymentGateway\\StructType\\To',
            'From' => '\\SabrePaymentGateway\\StructType\\From',
            'Description' => '\\SabrePaymentGateway\\StructType\\Description',
            'Security' => '\\SabrePaymentGateway\\StructType\\Security',
            'UsernameToken' => '\\SabrePaymentGateway\\StructType\\UsernameToken',
        );
    }
}
