<?php

namespace SabrePaymentGateway\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomIdentifiersType StructType
 * @subpackage Structs
 */
class CustomIdentifiersType extends AbstractStructBase
{
    /**
     * The CustomIdentifier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \SabrePaymentGateway\StructType\CustomIdentifier[]
     */
    public $CustomIdentifier;
    /**
     * Constructor method for CustomIdentifiersType
     * @uses CustomIdentifiersType::setCustomIdentifier()
     * @param \SabrePaymentGateway\StructType\CustomIdentifier[] $customIdentifier
     */
    public function __construct(array $customIdentifier = array())
    {
        $this
            ->setCustomIdentifier($customIdentifier);
    }
    /**
     * Get CustomIdentifier value
     * @return \SabrePaymentGateway\StructType\CustomIdentifier[]|null
     */
    public function getCustomIdentifier()
    {
        return $this->CustomIdentifier;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomIdentifier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomIdentifier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomIdentifierForArrayConstraintsFromSetCustomIdentifier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $customIdentifiersTypeCustomIdentifierItem) {
            // validation for constraint: itemType
            if (!$customIdentifiersTypeCustomIdentifierItem instanceof \SabrePaymentGateway\StructType\CustomIdentifier) {
                $invalidValues[] = is_object($customIdentifiersTypeCustomIdentifierItem) ? get_class($customIdentifiersTypeCustomIdentifierItem) : sprintf('%s(%s)', gettype($customIdentifiersTypeCustomIdentifierItem), var_export($customIdentifiersTypeCustomIdentifierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomIdentifier property can only contain items of type \SabrePaymentGateway\StructType\CustomIdentifier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomIdentifier value
     * @throws \InvalidArgumentException
     * @param \SabrePaymentGateway\StructType\CustomIdentifier[] $customIdentifier
     * @return \SabrePaymentGateway\StructType\CustomIdentifiersType
     */
    public function setCustomIdentifier(array $customIdentifier = array())
    {
        // validation for constraint: array
        if ('' !== ($customIdentifierArrayErrorMessage = self::validateCustomIdentifierForArrayConstraintsFromSetCustomIdentifier($customIdentifier))) {
            throw new \InvalidArgumentException($customIdentifierArrayErrorMessage, __LINE__);
        }
        $this->CustomIdentifier = $customIdentifier;
        return $this;
    }
    /**
     * Add item to CustomIdentifier value
     * @throws \InvalidArgumentException
     * @param \SabrePaymentGateway\StructType\CustomIdentifier $item
     * @return \SabrePaymentGateway\StructType\CustomIdentifiersType
     */
    public function addToCustomIdentifier(\SabrePaymentGateway\StructType\CustomIdentifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \SabrePaymentGateway\StructType\CustomIdentifier) {
            throw new \InvalidArgumentException(sprintf('The CustomIdentifier property can only contain items of type \SabrePaymentGateway\StructType\CustomIdentifier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomIdentifier[] = $item;
        return $this;
    }
}
