<?php

namespace SabrePaymentGateway\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReturnURLsType StructType
 * @subpackage Structs
 */
class ReturnURLsType extends AbstractStructBase
{
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - documentation: URL Type e.g. SepgHpp
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The DefaultURL
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DefaultURL;
    /**
     * The ApprovedURL
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ApprovedURL;
    /**
     * The DeclinedURL
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DeclinedURL;
    /**
     * The PendingURL
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $PendingURL;
    /**
     * The CancelURL
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CancelURL;
    /**
     * The ExpiredURL
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ExpiredURL;
    /**
     * The ErrorURL
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ErrorURL;
    /**
     * The ChallengeURL
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ChallengeURL;
    /**
     * The WebhookURL
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $WebhookURL;
    /**
     * Constructor method for ReturnURLsType
     * @uses ReturnURLsType::setType()
     * @uses ReturnURLsType::setDefaultURL()
     * @uses ReturnURLsType::setApprovedURL()
     * @uses ReturnURLsType::setDeclinedURL()
     * @uses ReturnURLsType::setPendingURL()
     * @uses ReturnURLsType::setCancelURL()
     * @uses ReturnURLsType::setExpiredURL()
     * @uses ReturnURLsType::setErrorURL()
     * @uses ReturnURLsType::setChallengeURL()
     * @uses ReturnURLsType::setWebhookURL()
     * @param string $type
     * @param string $defaultURL
     * @param string $approvedURL
     * @param string $declinedURL
     * @param string $pendingURL
     * @param string $cancelURL
     * @param string $expiredURL
     * @param string $errorURL
     * @param string $challengeURL
     * @param string $webhookURL
     */
    public function __construct($type = null, $defaultURL = null, $approvedURL = null, $declinedURL = null, $pendingURL = null, $cancelURL = null, $expiredURL = null, $errorURL = null, $challengeURL = null, $webhookURL = null)
    {
        $this
            ->setType($type)
            ->setDefaultURL($defaultURL)
            ->setApprovedURL($approvedURL)
            ->setDeclinedURL($declinedURL)
            ->setPendingURL($pendingURL)
            ->setCancelURL($cancelURL)
            ->setExpiredURL($expiredURL)
            ->setErrorURL($errorURL)
            ->setChallengeURL($challengeURL)
            ->setWebhookURL($webhookURL);
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \SabrePaymentGateway\StructType\ReturnURLsType
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get DefaultURL value
     * @return string|null
     */
    public function getDefaultURL()
    {
        return $this->DefaultURL;
    }
    /**
     * Set DefaultURL value
     * @param string $defaultURL
     * @return \SabrePaymentGateway\StructType\ReturnURLsType
     */
    public function setDefaultURL($defaultURL = null)
    {
        // validation for constraint: string
        if (!is_null($defaultURL) && !is_string($defaultURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($defaultURL, true), gettype($defaultURL)), __LINE__);
        }
        $this->DefaultURL = $defaultURL;
        return $this;
    }
    /**
     * Get ApprovedURL value
     * @return string|null
     */
    public function getApprovedURL()
    {
        return $this->ApprovedURL;
    }
    /**
     * Set ApprovedURL value
     * @param string $approvedURL
     * @return \SabrePaymentGateway\StructType\ReturnURLsType
     */
    public function setApprovedURL($approvedURL = null)
    {
        // validation for constraint: string
        if (!is_null($approvedURL) && !is_string($approvedURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($approvedURL, true), gettype($approvedURL)), __LINE__);
        }
        $this->ApprovedURL = $approvedURL;
        return $this;
    }
    /**
     * Get DeclinedURL value
     * @return string|null
     */
    public function getDeclinedURL()
    {
        return $this->DeclinedURL;
    }
    /**
     * Set DeclinedURL value
     * @param string $declinedURL
     * @return \SabrePaymentGateway\StructType\ReturnURLsType
     */
    public function setDeclinedURL($declinedURL = null)
    {
        // validation for constraint: string
        if (!is_null($declinedURL) && !is_string($declinedURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($declinedURL, true), gettype($declinedURL)), __LINE__);
        }
        $this->DeclinedURL = $declinedURL;
        return $this;
    }
    /**
     * Get PendingURL value
     * @return string|null
     */
    public function getPendingURL()
    {
        return $this->PendingURL;
    }
    /**
     * Set PendingURL value
     * @param string $pendingURL
     * @return \SabrePaymentGateway\StructType\ReturnURLsType
     */
    public function setPendingURL($pendingURL = null)
    {
        // validation for constraint: string
        if (!is_null($pendingURL) && !is_string($pendingURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pendingURL, true), gettype($pendingURL)), __LINE__);
        }
        $this->PendingURL = $pendingURL;
        return $this;
    }
    /**
     * Get CancelURL value
     * @return string|null
     */
    public function getCancelURL()
    {
        return $this->CancelURL;
    }
    /**
     * Set CancelURL value
     * @param string $cancelURL
     * @return \SabrePaymentGateway\StructType\ReturnURLsType
     */
    public function setCancelURL($cancelURL = null)
    {
        // validation for constraint: string
        if (!is_null($cancelURL) && !is_string($cancelURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cancelURL, true), gettype($cancelURL)), __LINE__);
        }
        $this->CancelURL = $cancelURL;
        return $this;
    }
    /**
     * Get ExpiredURL value
     * @return string|null
     */
    public function getExpiredURL()
    {
        return $this->ExpiredURL;
    }
    /**
     * Set ExpiredURL value
     * @param string $expiredURL
     * @return \SabrePaymentGateway\StructType\ReturnURLsType
     */
    public function setExpiredURL($expiredURL = null)
    {
        // validation for constraint: string
        if (!is_null($expiredURL) && !is_string($expiredURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expiredURL, true), gettype($expiredURL)), __LINE__);
        }
        $this->ExpiredURL = $expiredURL;
        return $this;
    }
    /**
     * Get ErrorURL value
     * @return string|null
     */
    public function getErrorURL()
    {
        return $this->ErrorURL;
    }
    /**
     * Set ErrorURL value
     * @param string $errorURL
     * @return \SabrePaymentGateway\StructType\ReturnURLsType
     */
    public function setErrorURL($errorURL = null)
    {
        // validation for constraint: string
        if (!is_null($errorURL) && !is_string($errorURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorURL, true), gettype($errorURL)), __LINE__);
        }
        $this->ErrorURL = $errorURL;
        return $this;
    }
    /**
     * Get ChallengeURL value
     * @return string|null
     */
    public function getChallengeURL()
    {
        return $this->ChallengeURL;
    }
    /**
     * Set ChallengeURL value
     * @param string $challengeURL
     * @return \SabrePaymentGateway\StructType\ReturnURLsType
     */
    public function setChallengeURL($challengeURL = null)
    {
        // validation for constraint: string
        if (!is_null($challengeURL) && !is_string($challengeURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($challengeURL, true), gettype($challengeURL)), __LINE__);
        }
        $this->ChallengeURL = $challengeURL;
        return $this;
    }
    /**
     * Get WebhookURL value
     * @return string|null
     */
    public function getWebhookURL()
    {
        return $this->WebhookURL;
    }
    /**
     * Set WebhookURL value
     * @param string $webhookURL
     * @return \SabrePaymentGateway\StructType\ReturnURLsType
     */
    public function setWebhookURL($webhookURL = null)
    {
        // validation for constraint: string
        if (!is_null($webhookURL) && !is_string($webhookURL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($webhookURL, true), gettype($webhookURL)), __LINE__);
        }
        $this->WebhookURL = $webhookURL;
        return $this;
    }
}
